﻿using HarmonyLib;
using RimWorld;
using Verse;

namespace VexedThings.HarmonyPatches
{
	// Makes pawns stunnable by emp attacks.
	[HarmonyPatch(typeof(StunHandler), "get_AffectedByEMP")]
	public class AffectedByEMP_HarmonyPatch
	{
		[HarmonyPostfix]
		public static void PostFix(StunHandler __instance, ref bool __result, Thing ___parent)
		{
			if (___parent is Pawn)
			{
				Pawn pawn = (Pawn)___parent;
				if (pawn != null && pawn.def.HasModExtension<PawnsSynthetic>() &&
				pawn.def.GetModExtension<PawnsSynthetic>().canBeStunnedByEMP)
				{
					__result = true;
				}
			}
		}
	}


	// Stops corpses with these fleshTypes from being edible.
	[HarmonyPatch(typeof(Corpse), "get_IngestibleNow")]
	public class IngestibleNow_HarmonyPatch
	{
		[HarmonyPostfix]
		public static void PostFix(Corpse __instance, ref bool __result)
		{
			bool flag = !__result;
			if (!flag)
			{
				bool flag2 = __instance.InnerPawn.RaceProps.FleshType == FleshTypeDefOfSynth.VexedMechanical;
				if (flag2)
				{
					__result = false;
				}
				bool flag3 = __instance.InnerPawn.RaceProps.FleshType == FleshTypeDefOfSynth.VexedSynthetic;
				if (flag3)
				{
					__result = false;
				}
			}
		}
	}
}