﻿using System.Collections.Generic;
using Verse;
using RimWorld;

namespace VexedThings
{
    [StaticConstructorOnStartup]
    public static class CorpseTweaker
    {
        static CorpseTweaker()
        {
            foreach (ThingDef thingDef in DefDatabase<ThingDef>.AllDefs)
            {
                PawnsSynthetic tweaker = thingDef.GetModExtension<PawnsSynthetic>();
                if (tweaker != null)
                {
                    ThingDef corpseDef = thingDef?.race?.corpseDef;
                    if (corpseDef != null)
                    {
                        if (tweaker.corpseWillNotRot)
                        {
                          corpseDef.comps.RemoveAll(compProperties => compProperties is CompProperties_Rottable);
                          corpseDef.comps.RemoveAll(compProperties => compProperties is CompProperties_SpawnerFilth);
                        }
                    }
                }
            }
        }
    }
}
